import java.util.Random;

/**
 * @title Praktikum 1: Algorithmendesign (Prof. Ressel)
 * @date 19.04.2013
 *
 */
public class Versuch1
{
   /**
	* Erstellt ein Zufallsarray mit n Elementen zwischen 0 und k
	* @param n Gibt die Anzahl der zu erstellenden Zufallselementen an
	* @param k Gibt die obere Grenze der Zufallszahlen an
	* @return n Zufallszahlen zwischen 0 und k
	*/
	static int[] createRandomArray(int n, int k)
	{
		int i;
		int[] randomArray = new int[n];
		Random newGenerator = new Random();
		
		for(i = 0; i < n; i++)
		{
			randomArray[i] = newGenerator.nextInt(k);
		}
		
		return randomArray;
	}
	
	/**
	 * Gibt das Zufallsarray, das mit der Methode createRandomArray erstellt wurde, aus
	 * @param a Gibt die Methode, mit dem das Zufallsarray erstellt wird, an
	 */
	static void printArray(int[] a)
	{
		int i;
		
		for(i = 0; i < a.length; i++)
		{
			System.out.println(a[i]);
		}
	}
	
	/**
	 * Methode vertauscht das i-te und das j-te Element im Feld a miteinander
	 * @param a Quell/-Zielarray
	 * @param i Tauschelement
	 * @param j Tauschelement
	 */
	static void swap(int[] a, int i, int j)
	{
		int helpNumber;
		
		helpNumber = a[i];
		a[i] = a[j];
		a[j] = helpNumber;
	}
	
	/**
	 * Methode sortiert das Feld a mit Hilfe von Selection Sort
	 * @param a Gibt das zu sortierende Feld an
	 * @param n Gibt die Anzahl der zu sortierenden Elemente von Feld a an
	 * @TODO n implementieren
	 */
	public static void selectionSort(int[] a)
	{
		int i, j, temp;
		
		for(i = 0; i < a.length - 1; i++)
		{
			for(j = i + 1; j < a.length; j++)
			{
				if (a[i] > a[j])
				{
					temp = a[i];
					a[i] = a[j];
					a[j] = temp;
				}
			}
		}
	}
	
	/**
	 * Hilfs Methode fr mergeSort
	 * @param a a Gibt das zu sortierende Feld an
	 * @param l Linkeste Index
	 * @param m Mittlerer Index
	 * @param r Rechtester Index
	 */
   public static void merge(int[] a, int l, int m, int r)
   {    
	   	int i, j, k;
	   	
	   	//Groesse der beiden Teilfolgen
	   	int n1, n2;
	   	n1 = m - l + 1;
	   	n2 = r - m;
	   	
	   	//Speicher Teilfolgen in Hilfsarray
	   	int[] a1 = new int[n1];
	   	int[] a2 = new int[n2];
	   	
	   	for(i = 0; i < n1; i++)
	   	{
	   		a1[i] = a[l+i];
	   	}
	   	
	   	for(i = 0; i < n2; i++)
	   	{
	   		a2[i] = a[m+1+i];
	   	}
	   	
	   	//Mische die Teilfolgen solange eine Teilfolge leer ist
	   	k = l;
	   	i = 0;
	   	j = 0;
	   	
	   	while((i < n1) && (j < n2))
	   	{
	   		if(a1[i] < a2[j])
	   		{
	   			a[k] = a1[i];
	   			k++;
	   			i++;
	   		}
	   		else
	   		{
	   			a[k] = a2[j];
	   			k++;
	   			j++;
	   		}
	   	}
	   	
   		if(j >= n2)
   		{
   			for(j = i; j < n1; j++)
   			{
   				a[k] = a1[j];
   				k++;
   			}
   		}
   		else
   		{
   			for(i = j; i < n2; i++)
   			{
   				a[k] = a2[i];
   				k++;
   			}
   		}
   } 
	
	/**
	 * Methode sortiert das Feld mit Hilfe von MergeSort
	 * @param a Gibt das zu sortierende Feld an
	 * @param l Linkeste Index
	 * @param r Rechteste Index
	 */
	public static void mergeSort(int[] a, int l, int r)
	{
		if(l < r)
		{
			int m;
			
			m = (r + l) / 2;
			mergeSort(a, l, m);
			mergeSort(a, m+1, r);
			merge(a, l, m, r);
		}
	}
	
	/**
	 * Hilfsmethode fuer HeapSort, welche ein Element im Baum versenkt
	 * @param a Gibt das zu sortierende Feld an
	 * @param i Das heapify-Element
	 * @param n letzte Stelle im Baum die beachtet werden soll
	 */
	public static void heapify(int[] a, int i, int n)
	{
		int childIndex;
		
		while(i <= (n/2) - 1)
		{
			childIndex = ((i+1) * 2) - 1;
			if(childIndex + 1 <= n-1)
			{
				if(a[childIndex] < a[childIndex + 1])
				{
					childIndex++;
				}
			}
			
			if(a[i] < a[childIndex])
			{
				swap(a, i, childIndex);
				i = childIndex;
			}
			else
			{
				break;
			}
		}
	}
	
	/**
	 * Hilfsmethode fuer heapSort, welche einen MaximumHeap erstellt
	 * @param a Gibt das zu sortierende Feld an
	 */
	public static void buildHeap(int[] a)
	{
		int i;
		
		for(i = (a.length / 2) - 1; i >= 0; i--)
		{
			heapify(a, i , a.length);
		}
	}
	
	/**
	 * Methode sortiert das Feld mit Hilfe von Heap Sort
	 * @param a Gibt das zu sortierende Feld an
	 * @param n Gibt die Anzahl der zu sortierenden Elemente von Feld a an
	 */
	public static void heapSort(int[] a, int n)
	{
		int i;
		
		buildHeap(a);
		for(i = a.length - 1; i > 0; i--)
		{
			swap(a, i, 0);
			heapify(a, 0, i);
		}
	}
	
	/**
	 * 
	 * @param a Gibt das zu sortierende Feld an
	 * @param l Linker Index
	 * @param r rechter Index
	 * @return Index i
	 */
	static int partition(int a[], int l, int r)
	{
		  int i = l, j = r;
		  int tmp;
		  int pivot = a[(l + r) / 2];
		 
		  while (i <= j)
		  {
		        while (a[i] < pivot)
		        {
		              i++;
		        }
		        
		        while (a[j] > pivot)
		        {
		              j--;
		        }
		        
		        if (i <= j)
		        {
		              tmp = a[i];
		              a[i] = a[j];
		              a[j] = tmp;
		              i++;
		              j--;
		        }
		  }
		 
		  return i;
	}
	
	/**
	 * 
	 * @param a Gibt das zu sortierende Feld an
	 * @param l Linker Index
	 * @param r rechter Index
	 */
	public static void quickSort(int[] a, int l, int r)
	{
	      int index;
	      
	      index = partition(a, l, r);
	      if (l < index - 1)
	      {
	    	  quickSort(a, l, index - 1);
	      }
	            
	      if (index < r)
	      {
	    	  quickSort(a, index, r);
	      }
	}
	
	/**
	 * 
	 * @param a Gibt das zu sortierende Feld an
	 * @param k
	 */
	public static void countSort(int[] a, int k)
	{
		int i;
		int C[] = new int[k+1];
		int B[] = new int[a.length];
		
		for(i = 0; i <= k; i++)
		{
		    C[i] = 0;
		}
		
		for(i = 0; i < a.length; i++)
		{
			C[a[i]]++;
		}
		    
		for(i = 1; i < k; i++)
		{
			C[i] = C[i] + C[i-1];
		}
		
		for(i = a.length - 1; i >= 0; i--)
		{
			B[--C[a[i]]] = a[i];
		}

		for(i = 0; i < a.length;i++)
		{
			a[i] = B[i];
		}   
		
	}
	
	/**
	 * Sucht ein Element mit Hilfe von linearer Suche
	 * @param a Gibt das zu sortierende Feld an
	 * @param k gibt das zu suchende Element an
	 * @return liefert den Index des gefundenen Elements zurck
	 */
	static int linSearch(int[] a, int k)
	{
		int i;
		
		for(i = 0; i< a.length; i++)
		{
			if(a[i] == k)
			{
				return i;
			}
		}
		
		return -1;
	}
	
	/**
	 * Sucht ein Element mit Hilfe von binaerer Suche
	 * @param a Gibt das zu sortierende Feld an
	 * @param key gibt das zu suchende Element an
	 * @return liefert den Index des gefundenen Elements zurck
	 */
	static int binSearch(int[] a, int key)
	{
		int first = 0;
		int last = a.length - 1;

		while(first <= last)
		{
			final int middle = first + ((last - first) / 2);
			if(a[middle] < key)
			{
				first = middle + 1;
			}
			else if (a[middle] > key)
			{
				last = middle - 1;
			}
			else
			{
				return middle;
			}
		}
		
		return -1;
	}
	
	/**
	 * Sucht ein Element mit Hilfe von Interpolations Suche
	 * @param a Gibt das zu sortierende Feld an
	 * @param key gibt das zu suchende Element an
	 * @return liefert den Index des gefundenen Elements zurck
	 */
	static int interpolSearch(int[] a, int key)
	{
		int left = 0;
		int right = a.length - 1;
		int diff;
		int position;
		
		while((key >= a[left]) && (key <= a[right]))
		{
			diff = a[right] - a[left];
			position = left + (int)((((double)right - left) * (key - a[left])) / diff);
			if(key > a[position])
			{
				left = position + 1;
			}
			else if(key < a[position])
			{
				right = position - 1;
			}
			else
			{
				return position;
			}
		}
		
		return -1;
	}
	/**
	 * Methode berechnet den Mittel eines Arrays
	 * @param a long Array
	 * @return Mittelwert vom Array a
	 */
	public static long mittelwert(long a[])
	{
		long summe = 0;
		int i;
		
		for(i = 0; i< a.length - 1; i++)
		{
			summe +=a[i];
		}
		
		return (summe / (a.length - 1));		
	}
	
	/**
	 * Methode zum Testen der Sortieralgorithmen
	 */
	public static void testSort()
	{
		final int n = 100*1024;
		final int k = 1024;
		int randomArray[] = createRandomArray(n,k);
		int t;
		long tStart, tEnde;
		long[] tGesamt = new long[5];
		long middleWert;
		
		System.out.println("-- Auswertung: Sortieralgorithmen --\n");
		
		//selectionSort
		for(t = 0; t < 5; t++)
		{
			
			tStart = System.currentTimeMillis();
			selectionSort(randomArray);
			tEnde = System.currentTimeMillis();
			tGesamt[t] = (tEnde - tStart);
		}
		
		middleWert = mittelwert(tGesamt);
		System.out.println("SelectionSort: " + middleWert);
		
		//mergeSort
		for(t = 0; t < 5; t++)
		{
			tStart = System.currentTimeMillis();
			mergeSort(randomArray, 0, randomArray[randomArray.length - 1]);
			tEnde = System.currentTimeMillis();
			tGesamt[t] = (tEnde - tStart);
		}
		middleWert = mittelwert(tGesamt);
		System.out.println("MergeSort: " + middleWert);
		
		//heapSort
		for(t = 0; t < 5; t++)
		{
			tStart = System.currentTimeMillis();
			heapSort(randomArray, n);
			tEnde = System.currentTimeMillis();
			tGesamt[t] = (tEnde - tStart);
		}
		middleWert = mittelwert(tGesamt);
		System.out.println("HeapSort: " + middleWert);
		
		//quickSort
		for(t = 0; t < 5; t++)
		{
			tStart = System.currentTimeMillis();
			quickSort(randomArray, 0, randomArray[randomArray.length - 1]);
			tEnde = System.currentTimeMillis();
			tGesamt[t] = (tEnde - tStart);
		}
		middleWert = mittelwert(tGesamt);
		System.out.println("QuickSort: " + middleWert);
		
		//countsort
		for(t = 0; t < 5; t++)
		{
			tStart = System.currentTimeMillis();
			countSort(randomArray, k);
			tEnde = System.currentTimeMillis();
			tGesamt[t] = (tEnde - tStart);
		}
		middleWert = mittelwert(tGesamt);
		System.out.println("CountSort: " + middleWert);
	}
	
	/**
	 * Methode zum Testen der Suchalgorithmen
	 * Info: Um wirklich Laufzeiten zu erkennen, muessen EXTREM grosse Werte fuer n definiert werden. 
	 * Dies kann schnell zum Ueberlauf vom Java Heap kommen, welcher mit Hilfe des Befehls von
	 * "java -Xmx<Heapsize>" auf einen gewuenschten Wert vergroessert werden kann.
	 * Bsp: java -Xmx4096M
	 */
	public static void testSearch()
	{
		int n = 5000 * 1024;
		final int k = 1024;
		int randomArray[] = createRandomArray(n,k);
		int t;
		long tStart, tEnde;
		long[] tGesamt = new long[5];
		long middleWert;
		
		System.out.println("\n\n-- Auswertung: Suchalgorithmen --\n");
		
		//linSearch
		for(t = 0; t < 5; t++)
		{
			randomArray = createRandomArray(n,k);
			tStart = System.currentTimeMillis();
			linSearch(randomArray, randomArray[randomArray.length - 1]);
			tEnde = System.currentTimeMillis();
			tGesamt[t] = (tEnde - tStart);
		}
		middleWert = mittelwert(tGesamt);
		System.out.println("linSearch: " + middleWert);
		
		//binSearch
		for(t = 0; t < 5; t++)
		{
			randomArray = createRandomArray(n,k);
			heapSort(randomArray, n);
			tStart = System.currentTimeMillis();
			binSearch(randomArray, randomArray[randomArray.length - 1]);
			tEnde = System.currentTimeMillis();
			tGesamt[t] = (tEnde - tStart);
		}
		middleWert = mittelwert(tGesamt);
		System.out.println("binSearch: " + middleWert);
		
		
		//interpolSearch
		for(t = 0; t < 5; t++)
		{
			heapSort(randomArray, n);
			tStart = System.currentTimeMillis();
			interpolSearch(randomArray, randomArray[randomArray.length - 1]);
			tEnde = System.currentTimeMillis();
			tGesamt[t] = (tEnde - tStart);
		}
		middleWert = mittelwert(tGesamt);
		System.out.println("interpolSearch: " + middleWert);
	}
	
	public static void main(String[] args)
	{	
		testSort();
		testSearch();
	}
}
